#ifndef __CLC__H
#define __CLC__H

//
// http://www.geocities.com/cl2cru/
// Vladislav R. Bulatov 08.10.2000
//


//#define SEQUENCE_HANDLING_SUPPORT

#ifdef SEQUENCE_HANDLING_SUPPORT
#define SEQUENCE_HANDLING_PROLOGUE  \
  if (!_CLC_is_set_jmp && CLC_setjmp (_CLC_jmp) == 1) return;
#else
#define SEQUENCE_HANDLING_PROLOGUE
#endif

#ifdef __cplusplus
extern "C"{
#endif

#define STATIC enum
#define ST(a) (CLC_sbase[(int)(a)])
#define LONGCAST(a) ((a)->val.integer)
#define INTCAST(a) (int)((a)->val.integer)
#define LOGCAST(a) ((a)->val.log)

extern ITEM CHECKVARTYPE (ITEM v, int t);
extern void _fastcall CLCCHECKTYPE (int t);
extern ITEM NILCHECKVARTYPE (ITEM v, int t);
extern void NILCLCCHECKTYPE (int t);

extern void _fastcall CLC_ConCat (int);

extern void _fastcall CLC_puta2 (void);
extern void _fastcall CLC_puta1 (unsigned ndx, int type);
extern void _fastcall CLC_puta1any (unsigned ndx);
extern ITEM _fastcall CLC_puta0 (ITEM  v, unsigned ndx, int type);
extern ITEM _fastcall CLC_puta0any (ITEM  v, unsigned ndx);

extern void _fastcall CLC_popa0 (ITEM a, unsigned ndx, ITEM  val);
extern void _fastcall CLC_popa1 (ITEM a, unsigned ndx);
extern void _fastcall CLC_popa2 (unsigned ndx);
extern void _fastcall CLC_popa3 (void);

extern ITEM _fastcall CLC_anyparam (int n);
extern ITEM _fastcall CLC_param (int n, int type);
extern long _fastcall CLC_lparam (int n);
extern void _fastcall CLC_argframe (int count);
extern void _fastcall CLC_frame (int ArgCount, int LocCount);
extern void _fastcall CLC_poparg (int n, ITEM );

extern int CLC_len0 (ITEM );
extern int CLC_len1 (void);

extern ITEM _fastcall CLC_putln (long);
#define _putln CLC_putln

extern void _fastcall CLC_WAVE (void);
extern void _fastcall CLC_WAVEPOPF (void);
extern void _fastcall CLC_WAVEPOPQ (void);
extern void _fastcall CLC_WAVEF (void);
extern void _fastcall CLC_WAVEQ (void);
extern void _fastcall CLC_WAVEP (void);
extern void _fastcall CLC_WSYMBOL (void);

typedef struct __jmp_buf {
    unsigned    j_sp;
    unsigned    j_ss;
    unsigned    j_flag;
    unsigned    j_cs;
    unsigned    j_ip;
    unsigned    j_bp;
    unsigned    j_di;
    unsigned    j_es;
    unsigned    j_si;
    unsigned    j_ds;
}   jmp_buf[1];

void    _cdecl CLC_longjmp(jmp_buf __jmpb, int __retval);
int     _cdecl CLC_setjmp(jmp_buf __jmpb);

#define _pull1() _tos -= 1
#define _pull2() _tos -= 2
#define _pulln(n) _tos -= (n)
#define _pull(n) _tos -= (n)

#ifdef __TURBOC__
unsigned cdecl __strlen__(const char far *__s);
int cdecl __strcmp__(const char far *__s1, const char far *__s2);
int cdecl __strncmp__(const char far *__s1, const char far *__s2,
			   unsigned __maxlen);
void far * __memcpy__(void far * __m1, const void far * __m2, unsigned __n);
char far * __strncpy__(char far *__dest, const char far *__src, unsigned);
char far * __strcpy__(char far *__dest, const char far *__src);

#pragma warn -wdup
#ifdef strlen
#undef strlen
#endif
#ifdef strcmp
#undef strcmp
#endif
#ifdef strncmp
#undef strncmp
#endif
#ifdef memcpy
#undef memcpy
#endif
#ifdef strcpy
#undef strcpy
#endif
#define strlen(a) __strlen__ (a)
#define strcmp(a,b) __strcmp__ (a,b)
#define strncmp(a,b,n) __strncmp__ (a,b,n)
#define memcpy(a,b,n) __memcpy__ (a,b,n)
#define strcpy(a,b) __strcpy__ (a,b)
#pragma warn +wdup
#endif

int _fastcall CLC_row (void);
int _fastcall CLC_col (void);
void _fastcall CLC_devpos (int, int);

void cdecl _gtSetPos (int, int);
int cdecl _gtMaxCol (void);
int cdecl _gtMaxRow (void);

#ifdef __cplusplus
}
#endif

#endif
