#ifndef __INTERNAL_CL
#define __INTERNAL_CL
//
// http://www.geocities.com/cl2cru/
// Vladislav R. Bulatov 08.10.2000
//

#include <clipdefs.h>

#ifdef __cplusplus
extern "C"{
#endif

typedef CLIPPER (far *RefClip)(void);

typedef struct _VALUE{
    unsigned short type;
    unsigned short len;
    unsigned short len1;
    union {
        long integer;
        int  log;
        char bytes[8];
        struct _VALUE near * locptr;
    } val;
} VALUE;

typedef VALUE near * ITEM;

extern ITEM _eval, _evalhigh, _tos, _sbase, _lbase;
extern int  _fzzcount;

extern int _salt;
extern int _pcount;

#define _putnil() ((++_tos)->type = T_NIL)

typedef struct{
    char    name[10];
    int     type;               // 0 - public, 1 - static
    struct sym_str * sym;
} _NAME;

typedef struct  sym_str {
     char unknow[6];
     int alias;
     _NAME far * name;
     RefClip code;
} SYM;

#define T_ARRAY     0x8000
#define T_LOCPTR    0x2000
#define T_NAMEPTR   0x4000
#define T_PTR       (T_NAMEPTR | T_LOCPTR)
#define T_BLOCK     0x1000
#define T_CHAR      0x0400
#define T_ALIAS     0x0200
#define T_SYM       0x0100
#define T_LOG       0x0080
#define T_DATE      0x0020
#define T_NUMERIC   0x000b
#define T_REAL      0x0008
#define T_INT       0x0002
#define T_NIL       0x0000

extern SYM *          _symEVAL;

extern ITEM           _actinfo (int);
extern void pascal    _arraynew (int);
extern int            _cAt (ITEM, unsigned short, signed short, ITEM);
extern int            _cAtAt (ITEM, unsigned short, unsigned short, signed short, ITEM);
extern int            _cAtPut (ITEM, unsigned short, ITEM);
extern void           _cResize (ITEM, int);
extern void           _ceval1 (ITEM, ITEM);
extern SYM *          _chk_sym (char *);
extern SYM *          _get_sym (char *);
extern void           _imakea (int);
extern void           _imakela (int);
extern void           _ipopf (SYM *);
extern void           _ipushf (SYM *);
extern void           _ipopm (SYM *);
extern void           _ipushm (SYM *);
extern void           _isaveret (void);
extern void           _isinit (SYM *);
extern ITEM           _param (unsigned short, unsigned short);
extern void           _putc (char *);
extern void           _putcl (char *, int);
extern void           _putl (short int);
extern void           _putln (long);
extern void           _putq (unsigned);
extern void           _putd (long);
extern void           _putsym (SYM far*);
extern void           _retl (int);
extern void           _retln (long);
extern void           _retq (unsigned);
extern long           _sptol (ITEM);
extern int pascal     _varraylen (ITEM);
extern char * pascal  _vstr (ITEM);
extern char * pascal  _vstrlock (ITEM);
extern char * pascal  _vstrunlock (ITEM);
extern char * pascal  _vstrx (ITEM);
extern int            _wave_ (void);
extern int            _wavef_ (void);
extern int            _wavep_ (void);
extern int            _wsymbol_ (void);
extern void           _xdo (short int);
extern void           _xeval(int);
extern void           _xpopm (VALUE far *);
extern void           _xpushm (VALUE far *);
extern VALUE far * pascal _varray (ITEM);
extern void           term (void);

#ifdef __cplusplus
}
#endif

#include "filesys.api"

#define _twrite _fsWrite

#endif
